#ifndef APPSETTINGS_H
#define APPSETTINGS_H

#include <QObject>
#include <QSettings>
#include <QStandardPaths>
#include "scstwremotesettings.h"

class ScStwAppSettings : public ScStwRemoteSettings
{
    Q_OBJECT
public:
    explicit ScStwAppSettings(ScStwClient * scStwClient, QObject *parent = nullptr);
    ~ScStwAppSettings();

    enum AppInternalSetting {
        InvalidSetting = -1,
        AppThemeSetting,
        BaseStationIpSetting
    };
    Q_ENUM(AppInternalSetting)

    enum KeyLevelEnum {
        KeyLevel = 1
    };
    Q_ENUM(KeyLevelEnum)

    using ScStwSettings::readSetting;
    Q_INVOKABLE QVariant readSetting(AppInternalSetting key);
    Q_INVOKABLE QVariant readSetting(int key, int level);
    using ScStwSettings::writeSetting;
    Q_INVOKABLE bool writeSetting(AppInternalSetting key, QVariant value);
    Q_INVOKABLE bool writeSetting(int key, QVariant value, int level);
    using ScStwSettings::setDefaultSetting;
    Q_INVOKABLE void setDefaultSetting(AppInternalSetting key, QVariant defaultVariant);

signals:

public slots:

};
extern ScStwAppSettings * pGlobalAppSettings;

#endif // APPSETTINGS_H
